package com.sun.xml.internal.ws.api.server;

import javax.xml.stream.XMLStreamException;
import javax.xml.stream.XMLStreamWriter;
import java.io.IOException;
import java.io.OutputStream;
import com.sun.istack.internal.Nullable;
import java.net.URL;
import java.util.Set;
import com.sun.org.glassfish.gmbal.ManagedAttribute;
import javax.xml.namespace.QName;
import com.sun.org.glassfish.gmbal.ManagedData;

@ManagedData
public interface SDDocument
{
    @ManagedAttribute
    public abstract QName getRootName();
    
    @ManagedAttribute
    public abstract boolean isWSDL();
    
    @ManagedAttribute
    public abstract boolean isSchema();
    
    @ManagedAttribute
    public abstract Set<String> getImports();
    
    @ManagedAttribute
    public abstract URL getURL();
    
    public abstract void writeTo(@Nullable PortAddressResolver p0, DocumentAddressResolver p1, OutputStream p2) throws IOException;
    
    public abstract void writeTo(PortAddressResolver p0, DocumentAddressResolver p1, XMLStreamWriter p2) throws XMLStreamException, IOException;
    
    public interface Schema extends SDDocument
    {
        @ManagedAttribute
        public abstract String getTargetNamespace();
    }
    
    public interface WSDL extends SDDocument
    {
        @ManagedAttribute
        public abstract String getTargetNamespace();
        
        @ManagedAttribute
        public abstract boolean hasPortType();
        
        @ManagedAttribute
        public abstract boolean hasService();
        
        @ManagedAttribute
        public abstract Set<QName> getAllServices();
    }
}
